SystemOrganization addCategory: #'Mondrian-Help'!
SystemOrganization addCategory: #'Mondrian-Help-Tests'!

CustomHelp subclass: #MondrianHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Help'!

!MondrianHelp commentStamp: '<historical>' prior: 0!
MondrianHelp is use the HelpSystem to provide a brief help of Mondrian

Class collaborations
	MOEaselCommandAbout 

Class public API
		#bookName	#credits	#easel	#features	#howToContribute	#icon	#introduction	#license	#limits	#pages	#platforms	#su	#successStories

Testing classes
	MondrianHelpTest 

Comments written by AlexandreBergel on 28 April 2011
!

!MondrianHelp classSide methodsFor: 'accessing' stamp: 'AlexandreBergel 9/16/2010 19:21'!
bookName 
	^'Mondrian'! !

!MondrianHelp classSide methodsFor: 'documentation' stamp: 'AlexandreBergel 9/18/2010 07:17'!
credits
	^ HelpTopic 
		title: 'Credits'
		contents: 
'Mondrian has been originally developed on Visualworks by Michael Meyer and Tudor Girba in 2006. A port for Pharo has been initiated by Lukas Renggli. Alexandre Bergel became involved and has significantly improved the Pharo version since 2008. By being originally made for visualizing software, the community of the Moose platform quickly adopted Mondrian as its principal visualization engine. The current version of Mondrian is the result of a global community effort.  

The best way is to reach Mondrian developpers is probably the moose mailing list. If you have an interest in Mondrian,  https://www.iam.unibe.ch/mailman/listinfo/moose-dev is the place you want to go right away. The mailing list archive may be browsed.
Beside the mailing list, the main developper of Mondrian may be reached by sending email to alexandre@bergel.eu.
'! !

!MondrianHelp classSide methodsFor: 'documentation' stamp: 'AlexandreBergel 9/16/2010 23:13'!
easel
	^ HelpTopic 
		title: 'Easel'
		contents: 
'
The Mondrian easel is an interactive scripting engine that easily lets one experiment with scripting Mondrian.

New command may be added by subclassing MOEaselCommand. The new command may either appear in an existing menu or in a new menu. Creating a new command requires implementing at least three methods: execute, priority and title. The message execute will be sent upon selecting the menu item or the button the command represent. Priority is used to position your command among the others.  An increasing priority represents location from left to right. The title is simply a string. 

A command may have an icon by overriding the icon method. Per default, a command is a menu item. In that case, the  group class side method must return the name of the item menu in which the menu item will be inserted. A new menu item group will be created if it does not exist. A command is represented by a button if isMenu is overriden to return the true value. 
'! !

!MondrianHelp classSide methodsFor: 'documentation' stamp: 'AlexandreBergel 9/16/2010 21:11'!
features
	^ HelpTopic 
		title: 'Features'
		contents: 
'
Features of Mondrian are numerous. 

GENERAL MODEL VISUALIZATION 
Mondrian is primarily made to visualize graph of objects. As soon as your objects live in the Smalltalk memory, graphical representation may be attached to represent entities and their relationship.


DOMAIN SPECIFIC LANGUAGE
A simple and concise language is offered to easily describe visualization and interactions.


INTERACTIVE SCRIPTING ENGINE
Visualizations are scripted using the Mondrian domain specific language. Scripts may be "programmatically" defined or entered within an "easel". The Mondrian easel enables incremental script edification while providing immediate visual feedback.


EXTENSIBLE SET OF SHAPES
Mondrian comes with a set of predefined shapes (rectangle, ellipse, triangle, diamond for nodes, and possibily arrowed lines for edges). Custom shapes may be defined by using a form builder or creating new Smalltalk classes.


NUMEROUS LAYOUT
To be visually relevant, graphes may be ordered using using of the numerous layouts.


GRAPHVIZ SUPPORT
GraphViz is another widely used library for graph layout. Graph rendered in Mondrian may transparently use layouts offered by GraphViz.


GRAPH EMBEDDING
Any node may embed a graph in itself. Recursive graph offers rich possibilities to render data containement. 


EXTENDED INTERACTION SUPPORT
A Large set of events offer extended interaction possibilities.


POPUP VIEW
Rich contextual information are one mouse wave away.
'! !

!MondrianHelp classSide methodsFor: 'documentation' stamp: 'AlexandreBergel 9/16/2010 23:20'!
howToContribute
	^ HelpTopic 
		title: 'How to contribute'
		contents: 'The Mondrian community is growing. As most open source project, You can directly contribute to Mondrian in many different ways: proposing code enhancement, reporting bugs in the google code website, answering questions in the Moose mailing list.  
Even simply trying it out and asking questions is quite valuable since it helps us to figure out how Mondrian is perceived by new commers.. 
'
		! !

!MondrianHelp classSide methodsFor: 'accessing' stamp: 'AlexandreBergel 9/16/2010 19:21'!
icon
	^HelpIcons iconNamed: #packageIcon! !

!MondrianHelp classSide methodsFor: 'documentation' stamp: 'AlexandreBergel 9/16/2010 19:33'!
introduction
	^ HelpTopic 
		title: 'Introduction'
		contents: 'Mondrian is a visualization engine that offers a rich domain specific language to define graph-based rendering. 
Mondrian is commonly used to visualize software source code. However, it may be employed to visualize any Smalltalk objects and their relation.

Each element of a graph (ie node and edge) has a shape that defines its visual aspect. Many shapes are included in the Mondrian distribution. Complex shapes may be modelled using a form builder or by subclassing the class .', MOShape name, ' 

Nodes may be ordered using a layout. Available layouts may be found in the ', MOHorizontalLineLayout category asString ,' class category. Additional (and scalable) layouts may be obtained by installing the GraphViz bridge.

An interactive scripting engine is offered and is called Easel. Mondrian comes with an extensive set of tests and examples. The examples are accessible from the easel. An easel may be opened using the world menu or by evaluating "MOEasel open".
'! !

!MondrianHelp classSide methodsFor: 'documentation' stamp: 'AlexandreBergel 9/16/2010 19:34'!
license
	^ HelpTopic 
		title: 'License'
		contents: MOEaselCommandAbout new license! !

!MondrianHelp classSide methodsFor: 'documentation' stamp: 'Alexandre Bergel 11/15/2010 18:16'!
limits
	^ HelpTopic 
		title: 'Limitations'
		contents: 
'By being a general purpose visualization engine, Mondrian exhibits may features, but also a number of limitations. The principals limitations of Mondrian are:

- scalability: over 15 000 nodes and 3 000 edges, you may find the rendering taking too much time. This is an important limitation that is seriously considered by Mondrian developers. Over the time, many cache mechanisms have been been introduced to speed up rendering. We are currently investigating new mechanisms for pushing the limit of nodes and edges further. 

- Available Layouts: Mondrian comes with a large set of layouts. Making layout scalable and customisable for all the different usage that may be foreseen remains challenging. We are currently addressing this issue by making interaction with external libraries such as GraphViz easier.
 '! !

!MondrianHelp classSide methodsFor: 'accessing' stamp: 'AlexandreBergel 9/17/2010 04:36'!
pages
	^#(introduction features limits platforms easel successStories credits license)! !

!MondrianHelp classSide methodsFor: 'documentation' stamp: 'AlexandreBergel 9/18/2010 07:18'!
platforms
	^ HelpTopic 
		title: 'Platforms'
		contents: 
'Mondrian is developped, maintained and tested on Pharo (http://www.pharo-project.org). An outdated version of Mondrian may be found for Visualworks (http://www.cincomsmalltalk.com) and Squeak (www.squeak.org).

If you want to see Mondrian running on another Smalltalk platform, contact alexandre@bergel.eu for support.

This help focuses on the Pharo version. Although a great of effort has been spent on making the Pharo version compatible with the Visualworks version, some differences may exist. 
'! !

!MondrianHelp classSide methodsFor: 'documentation' stamp: 'AlexandreBergel 9/17/2010 04:36'!
successStories
	^ HelpTopic 
		title: 'Success stories'
		contents: 
'
Mondrian has been adopted by the main visualization engine in Moose. This means that most of the tools built in Moose exclusively rely on Mondrian to render software visualizations. A non exclusive list includes:
  - eDSM
  - Torch
  - Glamour
  - Package blueprint
  - Spy

Mondrian is known to be used at:
  - University of Brussels, Belgium
  - INRIA Lille Nord Europe, France
  - Ecole des Mines de Douai, France
  - University of Nice Sophia-Antipolis, France
  - University of Bern, Switzerland
  - University of Lugano, Switzerland
  - Netstyle.ch, Switzerland
  - University of Cauca, Columbia
  - University of Chile, Chile
'! !

TestCase subclass: #MondrianHelpTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Help-Tests'!

!MondrianHelpTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/11/2011 22:07'!
testOpeningBrowser
	| browser |
	browser := (HelpBrowser defaultHelpBrowser new) rootTopic: MondrianHelp.
	browser refresh! !

AbstractTutorial subclass: #MondrianTutorial
	instanceVariableNames: 'latexTheme pictureIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Help'!

!MondrianTutorial commentStamp: '<historical>' prior: 0!
MondrianTutorial is a ProfStef-tutorial. A generation to Latex is supported. 

Class collaborations
	PharoByExampleLatexTheme LatexTheme MORoot MOViewRenderer StandAloneLatexTheme MOEaselCommandTutorial 

Class public API
		#generateAndInsertImages:	#generateToLatex	#generateToLatexForTheme:	#introductionText	#latexTheme:	#t01Introduction	#t02FirstVisualization	#t03VisualizingClasses	#t04GivingANewShape	#t05MultipleEdges	#t06Colors	#t07MoreOnColors	#t08Popupview	#t09Subviews	#t10ForwardingEvents	#t11Events	#t12Interactions	#t13Conclusion	#translateLessonIntoLatex:	#tutorial	#writeBodyOn:	#writeFootOn:	#writeHeaderOn:	#writeLesson:on:

Testing classes
	MondrianTutorialTest 

Instance Variables:
	latexTheme --  An instance of LatexTheme
	pictureIndex --  figure reference. An integer

Comments written by AlexandreBergel on 28 April 2011
!

!MondrianTutorial methodsFor: 'latex generation - private' stamp: 'AlexandreBergel 11/17/2010 15:39'!
generateAndInsertImages: aLesson
	| lesson runningIndex beginningIndex codeToExecute endIndex newLesson pictureName form fullFileName |
	lesson := aLesson copy.
	newLesson := ''.
	runningIndex := 1.
	[
		beginningIndex := lesson findString: '<codeWithImage>' startingAt: runningIndex.
		beginningIndex = 0 ifTrue: [ 
			newLesson := newLesson, (lesson copyFrom: runningIndex to: lesson size).
			^ newLesson ].
		newLesson := newLesson, (lesson copyFrom: runningIndex to: beginningIndex - 1).
		endIndex := lesson findString: '</codeWithImage>' startingAt: runningIndex.
		codeToExecute := lesson 
								copyFrom: beginningIndex +  '<codeWithImage>'  size
								to: endIndex - 1.
		pictureName := 'picture', pictureIndex printString ,'.png'.
		newLesson := newLesson, '<code>', codeToExecute, '</code>', String cr, 
						'<image>', pictureName, '</image>'. 
		codeToExecute := ' | view | view := MOViewRenderer new. ', 
								String cr, 
								codeToExecute,
								'. view root applyLayout. view getRenderedForm'.
		pictureIndex := pictureIndex + 1.
		
		"We create a folder first"
		(FileDirectory default directoryExists: 'figures')
			ifFalse: [ FileDirectory default createDirectory: 'figures' ].
		
		form := Compiler evaluate: codeToExecute.
		form := form replaceColor: Color transparent withColor:  Color white.
		fullFileName := 'figures', FileDirectory pathNameDelimiter asString, pictureName.
		FileDirectory default deleteFileNamed: fullFileName ifAbsent: [].
		PNGReadWriter putForm: form onFileNamed: fullFileName.
		
		runningIndex := endIndex + '</codeWithImage>' size.
		true ] whileTrue.

	self error: 'Should not be here'! !

!MondrianTutorial methodsFor: 'latex generation - public' stamp: 'Alexandre Bergel 11/17/2010 07:39'!
generateToLatex
	"
	This method translates the tutorial into latex. The format used by Pharo by Example is used.
	
	 MondrianTutorial new generateToLatex
	MondrianTutorial new generateToLatexForTheme: PharoByExampleLatexTheme new
	"
	self generateToLatexForTheme: StandAloneLatexTheme new! !

!MondrianTutorial methodsFor: 'latex generation - private' stamp: 'Alexandre Bergel 11/15/2010 20:03'!
generateToLatexForTheme: aTheme
	"
	This method translates the tutorial into latex. The format used by Pharo by Example is used.
	
	self new generateToLatex
	"
	| stream |
	latexTheme := aTheme.
	stream := FileStream forceNewFileNamed: 'Mondrian.tex'.
	self writeHeaderOn: stream.
	self writeBodyOn: stream.
	self writeFootOn: stream! !

!MondrianTutorial methodsFor: 'initialize' stamp: 'Alexandre Bergel 11/16/2010 17:56'!
initialize
	super initialize.
	self resetPictureCounter! !

!MondrianTutorial methodsFor: 'introduction' stamp: 'AlexandreBergel 9/18/2010 21:23'!
introductionText
	^ 'This tutorial will progressively demonstrate the basic functionalities of Mondrian. At the end of the tutorial you will be able to create sophisticated visualizations.'! !

!MondrianTutorial methodsFor: 'accessing' stamp: 'Alexandre Bergel 11/15/2010 20:08'!
latexTheme
	latexTheme ifNil: [ latexTheme := StandAloneLatexTheme new ].
	^ latexTheme! !

!MondrianTutorial methodsFor: 'accessing' stamp: 'Alexandre Bergel 11/15/2010 20:07'!
latexTheme: anObject
	latexTheme := anObject! !

!MondrianTutorial methodsFor: 'initialize' stamp: 'Alexandre Bergel 11/16/2010 17:56'!
resetPictureCounter
	pictureIndex := 1! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'AlexandreBergel 9/12/2011 10:12'!
t01Introduction
	^ Lesson 
		title: 'Introduction'
		lesson: 
'Giving a meaning to a a large amount of data is challenging without adequate tools. Textual outputs are known to be limiting in their expression and interactions. 

Mondrian is an agile visualization engine. It is made to visualize and interact with any arbitrary data, defined in terms of objects and their relationships. Mondrian is commonly employed in software assessment activities. Mondrian excels at visualizing software source code. This chapter introduces Mondrian''s principles and describes its expressive commands to quickly make up your data. After its reading, you will be able to create interactive and visual representation.
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'AlexandreBergel 9/12/2011 10:23'!
t02FirstVisualization
	^ Lesson 
		title: 'Installation and first visualization'
		lesson: 
'
Mondrian is available via a Metacello configuration. Just open a workspace and type:

<code>
Gofer new
	squeak-source: ''Mondrian''; 
	package: ''ConfigurationOfMondrian'';
	load.
(Smalltalk at: #ConfigurationOfMondrian) loadDefault
</code>

There are essentially two ways to work with Mondrian. By either using the easel which provides an interactive scripting engine or by directly interacting with a view renderer. We will first use Mondrian in its easiest way, by using the easel. To open an easel, you can either use the World menu (it should contains the entry ``Mondrian Easel'') or execute the expression:

\begin{code}{}
MOEasel open.
\end{code}

In the easel you have just opened, you can see two panels: the one on top is the visualization panel, the second one is the script panel. In the script panel, enter the following code and press the \emph{generate} button:

<codeWithImage>
view nodes: (1 to: 20).
</codeWithImage>

You should see in the top pane 20 small boxes lined up in the top left corner. You have just rendered the numerical set between 1 and 20. Each box represents a number. The amount of interaction you can do is quite limited for now. You can only drag and drop a number and get a tooltip that indicates its value. We will soon see how to define interactions. For now, let us explore the basic drawing capabilities of Mondrian.

We can add edges between nodes that we already drawn. Add a second line:

<codeWithImage>
view nodes: (1 to: 20).
view edgesFrom: [ :v | v * 2 ].
</codeWithImage>

Each number is linked with its double. Not all the doubles are visualized. For example, the double of 20 is 400, which is not part of the visualization. In that case, no edges is drawn. 

The message \emph{edgesFrom:} defines one edge per node, when possible. For each node that has been added in the visualization, an edge is defined between this node and a node lookup from the provided block.

Mondrian contains a number of layouts to order nodes. We use the circle layout:

<codeWithImage>
view nodes: (1 to: 20).
view edgesFrom: [ :v | v * 2 ].
view circleLayout.
</codeWithImage>

In the subsequent section we will visualize software code. Visualizing source code is often employed to discover patterns, useful when assessing code quality.
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'AlexandreBergel 9/12/2011 10:28'!
t03VisualizingClasses
	^ Lesson 
		title: 'Visualizing the collection framework'
		lesson: 
'We will now visualize Smalltalk classes. In the remaining of this section, we will intensively use Smalltalk reflection to make compelling examples. Let''s visualize the hierarchy of classes contained in the Collection framework:

<codeWithImage>
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout.
</codeWithImage>

We have used a tree layout to visualize Smalltalk class hierarchies. This layout is particularly adequate since Smalltalk is single-inheritance oriented. Collection is the root class of the Smalltalk collection framework library. The message <sel>withAllSubclasses</sel> returns the list of its subclasses.

Classes are ordered vertically along their inheritance link. A superclass is above its subclasses. 
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'AlexandreBergel 9/12/2011 10:44'!
t04GivingANewShape
	^ Lesson 
		title: 'Reshaping nodes'
		lesson: 
'
Mondrian visualizes graph of objects. Each object of the domain is associated to a graph element, a node or an edge. Graph element are not aware of their graphical representation. Graphical aspect is given by a shape. 

So far, we have solely use the default shape to represent node and edges. The default shape of a node is a five pixels wide square and the default shape of an edge is a thin straight gray line.

A number of dimensions defines the appearance of a shape: the width and the height of a rectangle, the size of a line dash, border and inner colors, for example. We will reshape the nodes of our visualization to convey more information about the internal structure of the classes we are visualizing. Consider:

<codeWithImage>
view shape rectangle
	width: [ :each | each instVarNames size * 3 ];
	height: [ :each | each methods size ].
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout.
</codeWithImage>

\figref{picture5} shows the result. Each class is represented as a box. <sel>Collection</sel>, the root of the hierarchy, is the top most box. The width of a class tells about the amount of instance variables it has. We multiply it by 3 to have more representative results. The height tells about the number of methods. We can immediately spot classes with many more methods than others: <sel>Collection</sel>, <sel>SequentiableCollection</sel>, <sel>String</sel>, <sel>CompiledMethod</sel>. Classes with more variables than others are: <sel>RunArray</sel> and <sel>SparseLargeTable</sel>.

Note that the expression 
<code>
view edgesFrom: #superclass
</code>

is equivalent to

<code>
view edges: Collection withAllSubclasses from: #yourself to: #superclass.
</code>

itself equivalent to
<code>
view 
	edges: Collection withAllSubclasses 
	from: [ :each | each superclass ] 
	to: [ :each | each  ].
</code>

Edges are created by computing the source and target node for each node provided as first argument. In Mondrian, the expression

<code>
[ :aClass | aClass superclass ].
</code>

is equivalent to
<code>
#superclass
</code>
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'Alexandre Bergel 11/16/2010 19:03'!
t05MultipleEdges
	^ Lesson 
		title: 'Multiple edges'
		lesson: 
'Multiple edges may be defined. In the previous section, edges where departed from the superclass to the running node. Alternatively, edges may depart from the running nodes to all subclasses. For that very purpose, we will use <sel>edges:from:toAll:</sel>, a variant of <sel>edges:from:to:</sel>.

<codeWithImage>
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ].
view nodes: Collection withAllSubclasses.
view edges: Collection withAllSubclasses from: #yourself toAll: #subclasses.
view treeLayout.
</codeWithImage>

With <sel>edges:from:toAll:</sel> and <sel>edgesFrom:</sel>, two edges cannot start from a unique node.

Time to time, you may need a finer grain for edge declaration. The following is commonly employed as in:

<code>
view nodes: (1 to: 5). 
view shape arrowedLine. 
view edges: { 1 -> 2 . 1 -> 5 . 4 -> 3 } from: #key to: #value. 
view circleLayout
</code>
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'Alexandre Bergel 11/16/2010 01:15'!
t06Colors
	^ Lesson 
		title: 'Adding colors'
		lesson: 
'Node color is an important information support, as the width and the height of a node. Color should be easy to pick to represent particular condition

The keyword if:fillColor: enables one to assign a color for a particular condition. Consider we want to extend the previous example by coloring abstract classes in red.

<code>
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	if: #isAbstractClass fillColor: Color red.
view nodes: Collection withAllSubclasses.

view edges: Collection withAllSubclasses from: #yourself toAll: #subclasses.

view treeLayout.
</code>

The method <sel>isAbstractClass</sel> is defined on Behavior and Metaclass. By sending the <sel>isAbstractClass</sel> to a class return a boolean value telling us whether the class is abstract or not. We recall that an abstract class in Smalltalk is a class that defines or inherits at least one  abstract method (i.e., which contain ''self subclassResponsibility'').

The message <sel>if:fillColor:</sel> may be sent to a shape to conditionally set a color

<code>
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	if: #isAbstractClass fillColor: Color red.
view nodes: Collection withAllSubclasses.

view edgesFrom: #superclass.

view treeLayout.
</code>

All red nodes represent abstract class. Waving the moose above a node make a text tooltip appear revealing its name. 

Extended possibilities exist to define interaction. We will review them in a future section. For now, if you are interested in opening a system browser directly from a node, you define this interaction:

<code>
view interaction action: #browse.
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	if: #isAbstractClass fillColor: Color red.
view nodes: Collection withAllSubclasses.

view edgesFrom: #superclass.

view treeLayout.
</code>

You can easily spot some red node that do not have subclasses. This indicates a design flow since an abstract must to have subclasses. It makes no sense for a class that is not supposed to be instantiated (since it is abstract) to not have a subclass.

The very same analyzes can be realized on your own classes.

<code>
view interaction action: #browse.
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	if: #isAbstractClass fillColor: Color red.
view nodes: (PackageInfo named: ''Mondrian'') classes.

view edgesFrom: #superclass.

view treeLayout.
</code>

A shape may contains more than one condition. Let''s distinguish abstract classes from classes that define abstract methods.

<code>
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	if: #isAbstractClass fillColor: Color lightRed;
	if: [:cls | cls methods anySatisfy: #isAbstract ] fillColor: Color red.

view nodes: Collection withAllSubclasses.

view edgesFrom: #superclass.

view treeLayout.
</code>

All red nodes are still abstract classes. Light red indicates classes that do not define abstract methods; strong red indicates classes that define at least one abstract method.
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'Alexandre Bergel 11/16/2010 19:08'!
t07MoreOnColors
	^ Lesson 
		title: 'More on colors'
		lesson: 
'Color may be defined in many different ways. For example, you can directly send <sel>fillColor:</sel> to a shape.

<code>
view shape rectangle
	fillColor: Color lightBlue.
</code>

The list of available colors may be found in the class side of the class Color. The intensity of a node color may also indicate a quantitative value. For example, the intensity of node color is linear to the number of lines of code defined in the class.

<code>
view interaction action: #browse.
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	linearFillColor: #numberOfLinesOfCode within: Collection withAllSubclasses.
view nodes: Collection withAllSubclasses.

view edgesFrom: #superclass.

view treeLayout.
</code>

The visualization you now obtain put in relation for each class the number of methods, the number of instance variable and the number of lines of code. You can easily spot differences between classes, which might suggest you some a refactoring activity. This visualization is named ''System complexity'', if you wish to know more about this visualization, you can refer to ''Polymetric Views---A Lightweight Visual Approach to Reverse Engineering'' (Transactions on Software Engineering, 2003). 

The message <sel>linearFillColor:within:</sel> takes as first argument a block function that return a numerical value. The second argument is a group of elements that is used to scale the intensity of each node. The block function is applied to each element of the group. The greatest value is set to black. The fading scales from 0 to this maximum.
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'Alexandre Bergel 11/16/2010 08:36'!
t08Popupview
	^ Lesson 
		title: 'Popup view'
		lesson: 
'Consider the example that indicate abstract classes. Assume now that we would like to know what are the abstract methods defined. An easy way to do, is to extend the popup text with the list of abstract methods. Putting the mouse above a class does not only give its name, but also the list of abstract methods defined in the class.

<code>
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	if: #isAbstractClass fillColor: Color lightRed;
	if: [:cls | cls methods anySatisfy: #isAbstract ] fillColor: Color red.
	
view interaction popupText: [ :aClass | 
	| stream |
	stream := WriteStream on: String new.
	(aClass methods select: #isAbstract thenCollect: #selector)
		do: [:sel | stream nextPutAll: sel; nextPut: $ ; cr].
	aClass name printString, '' => '', stream contents ].
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout.
</code>

Another view may be opened instead of a text. Consider the following view definition:

<code>
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	if: #isAbstractClass fillColor: Color lightRed;
	if: [:cls | cls methods anySatisfy: #isAbstract ] fillColor: Color red.
	
view interaction popupView: [ :element :secondView | 
	secondView shape rectangle 
		if: #isAbstract fillColor: Color red;
		size: 10.	
	secondView nodes: (element methods sortedAs: #isAbstract).
	secondView gridLayout gapSize: 2
	].
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout.
</code>

When the mouse enters a node, a new view is defined and displayed next to the node. The method <sel>popupView:</sel> receives a two-arguments block as parameters. The first parameter of the block is the element represented by the node located below the mouse. The second argument is a new view that will be opened.

In the example, we used <sel>sortedAs:</sel> to order the nodes representing methods. This method is defined on Collection and belongs to Mondrian. To see example usages of <sel>sortedAs:</sel>, browse its corresponding unit test:
<code>
ToolSet browse: MOViewRendererTest selector: #testSortedAs 
</code>
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'AlexandreBergel 12/7/2010 16:59'!
t09Subviews
	^ Lesson 
		title: 'Subviews'
		lesson: 
'Each node may embed a view. This is achieved via the keywords <sel>nodes:forEach:</sel> and <sel>node:forIt:</sel>. Consider an alternative view for visualizing abstract methods:

<codeWithImage>
view shape rectangle
	if: #isAbstractClass fillColor: Color lightRed.
view nodes: MOGraphElement withAllSubclasses forEach: [ :aClass | 
	view shape rectangle 
		if: #isAbstract fillColor: Color red.
	view nodes: (aClass methods sortedAs: #isAbstract).
	view gridLayout gapSize: 2. 
].
view edgesFrom: #superclass.
view treeLayout.
</codeWithImage>

Abstract classes are painted in light red and abstract method in intense red. 
Each node may embed any arbitrary view. Consider this script to visualize class hierarchies for each package of the Collection framework.

<codeWithImage>
packages := #(''Mondrian-Core'' ''Mondrian-Tests''
				 ''Collections-Arrayed'' )
					collect: [ :pName | PackageInfo named: pName ].
				
view nodes: packages forEach: [ :aPackage | 
	view nodes: (aPackage classes reject: #isTrait).
	view edgesFrom: #superclass.
	view treeLayout
].
</codeWithImage>

We see an interesting issue here. A little more information is here shown. Not only we see the hierarchies defined in each packages, but we also see inter-package links. We can supress relations between packages and indicate in blue classes for which their superclasses lives in a different package.

<code>
packages := #(''Mondrian-Core'' ''Mondrian-Tests''
				 ''Collections-Arrayed'' )
					collect: [ :pName | PackageInfo named: pName ].
				
view nodes: packages forEach: [ :aPackage | 
	| classes |
	classes := aPackage classes reject: #isTrait.
	view shape rectangle 
			if: [ :cls | (classes includes: cls superclass) not ] 
					fillColor: Color blue.
	view nodes: classes.
	classes := classes copy 
				select: [ :cls | classes includes: cls superclass ].
	view edges: classes from: #superclass to: #yourself.
	view treeLayout
].
</code>

Package names can be included above each box.

<codeWithImage>
packages := #(''Mondrian-Core'' ''Mondrian-Tests''
				 ''Collections-Arrayed'' )
					collect: [ :pName | PackageInfo named: pName ].

view shape rectangle withoutBorder.
view nodes: packages forEach: [ :aPackage | 
	view shape label text: #packageName.
	view node: aPackage.
	view node: aPackage forIt: [
		| classes |
		classes := aPackage classes reject: #isTrait.
		view shape rectangle 
			if: [ :cls | (classes includes: cls superclass) not ] 
					fillColor: Color blue.
		view nodes: classes.
		classes := classes copy 
				select: [ :cls | classes includes: cls superclass ].
		view edges: classes from: #superclass to: #yourself.
		view treeLayout
	].
	view verticalLineLayout center
].
</codeWithImage>
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'Alexandre Bergel 11/16/2010 08:41'!
t10ForwardingEvents
	^ Lesson 
		title: 'Forwarding events'
		lesson: 
'Package of the visualization given in the previous section may be moved by a simple drag and drop. However, the invisible outter node must be grabbed. The name and the hierarchy box may be dragged on their own still. A better adjustement is to let the package name and the hierarchy box to forward the event to the outter invisible node (when executing the script below, declare packages as a temporary variable ).

<code>
packages := PackageOrganizer default packageNames
				select: [ :name | name beginsWith: ''Collections-'' ] 
				thenCollect:  [ :name | PackageInfo named: name ].

view shape rectangle withoutBorder.
view nodes: packages forEach: [ :aPackage | 
	view shape label text: #packageName.
	view interaction forward.
	view node: aPackage.

	view interaction forward.
	view node: aPackage forIt: [
		| classes |
		classes := aPackage classes reject: #isTrait.
		view shape rectangle 
			if: [ :cls | (classes includes: cls superclass) not ] fillColor: Color blue.
		view nodes: classes.
		classes := classes copy select: [ :cls | classes includes: cls superclass ].
		view edges: classes from: #superclass to: #yourself.
		view treeLayout
	].
	view verticalLineLayout center
].
</code>

A node may now be dragged from its name or the hierarchy box. It may be useful to selectively forward events: <sel>forward:</sel> is a variant of <sel>forward</sel>.

<code>
packages := PackageOrganizer default packageNames
				select: [ :name | name beginsWith: ''Collections-'' ] 
				thenCollect:  [ :name | PackageInfo named: name ].

view shape rectangle withoutBorder.
view nodes: packages forEach: [ :aPackage | 
	view shape label text: #packageName.
	view interaction forward: MOMouseDrag.
	view node: aPackage.

	view interaction forward: MOMouseDrag.
	view node: aPackage forIt: [
		| classes |
		classes := aPackage classes reject: #isTrait.
		view shape rectangle 
			if: [ :cls | (classes includes: cls superclass) not ] fillColor: Color blue.
		view nodes: classes.
		classes := classes copy select: [ :cls | classes includes: cls superclass ].
		view edges: classes from: #superclass to: #yourself.
		view treeLayout
	].
	view verticalLineLayout center
].
</code>

Note that several nodes may be selected by pressing the Ctrl or Cmd key.
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'Alexandre Bergel 11/16/2010 08:42'!
t11Events
	^ Lesson 
		title: 'Events'
		lesson: 
'Each mouse movement, click and keyboard click correspond to a particular events in Mondrian. The root of the events is MOEvent. Event handler are defined directly on the interaction object.  

<code>
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	if: #isAbstractClass fillColor: Color lightRed;
	if: [:cls | cls methods anySatisfy: #isAbstract ] fillColor: Color red.
	
view interaction on: MOMouseDouble do: [ :ann | 
	(OBSystemBrowser onClass: ann modelElement) open
].
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout.
</code>

The block handler accepts one argument, the event generated. The object that triggered the event is obtained by sending <sel>modelElement</sel> to the event object. 
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'Alexandre Bergel 11/16/2010 08:48'!
t12Interactions
	^ Lesson 
		title: 'Interaction'
		lesson: 
'Mondrian offers a number of contextual interaction mechanisms. The interaction object contains a number of keywords for that purpose. Consider the example:

<code>
view interaction 
	highlightWhenOver: [:v | {v - 1 . v + 1. v + 4 . v - 4}].
view shape rectangle 
	width: 40;
	height: 30;
	withText.
view nodes: (1 to: 16).
view gridLayout gapSize: 2.
</code>

We will extend our running example with an indication about the test coverage. Consider the following script:

<code>
view shape rectangle
	width: [ :each | each instVarNames size * 3];
	height: [ :each | each methods size ];
	linearFillColor: #numberOfLinesOfCode within: Collection withAllSubclasses.
view nodes: Collection withAllSubclasses.
view edgesFrom: #superclass.
view treeLayout.

view shape rectangle withoutBorder.
view node: ''compound'' forIt: [
	view shape label.
	view node: ''Collection tests''.
	
	view node: ''Collection tests'' forIt: [
		| testClasses |
		testClasses := (PackageInfo named: ''CollectionsTests'') classes reject: #isTrait.
		view shape rectangle
			width: [ :cls | (cls methods inject: 0 into: [ :sumLiterals :mtd | sumLiterals + mtd allLiterals size]) / 100 ];
			height: [ :cls | cls numberOfLinesOfCode / 50 ].
		view interaction 
				highlightWhenOver: [ :cls | ((cls methods inject: #() 
												into: [:sum :el | sum , el allLiterals ]) select: [:v | v isKindOf: Association ] thenCollect: #value) asSet ].
		view nodes: testClasses.
		view edgesFrom: #superclass.
		view treeLayout ].
	
	view verticalLineLayout alignLeft
].
</code>

The script contains two parts. The first part is the ubiquitous system complexity of the collection framework. We have seen it a number of times already. The second part renders the tests contained in the CollectionsTests. The width of a class is the number of literals contained in it. The height is the number of lines of code. Since the collection tests makes a great use of traits to reuse code, these metrics have to be scaled down. When the mouse is put over a test unit, then all the classes of the collection framework referenced in this class are highlighted.
'! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'Alexandre Bergel 11/15/2010 19:24'!
t13Conclusion
	^ Lesson 
		title: 'Conclusion'
		lesson: 
'Mondrian is a perpetual evolving application. This tutorial intents to cover the features frequently used. If there is a topic you wish to see discussed here, send an email to alexandre@bergel.eu.

We hope you haved enjoyed it!!

'! !

!MondrianTutorial methodsFor: 'latex generation - private' stamp: 'Alexandre Bergel 11/16/2010 12:50'!
translateLessonIntoLatex: aLessonText
	"Take as input the definition of a lesson, and generate "
	| textCopy |
	textCopy := aLessonText copy.

"	self latexTheme mapping do: [ :assoc | textCopy := textCopy replaceAllRegex: assoc key with: assoc value ].
"
	textCopy := self generateAndInsertImages: textCopy.
	self latexTheme mapping 
		do: [ :assoc | 
				textCopy := textCopy copyWithRegex: assoc key matchesTranslatedUsing: assoc value  ].
	
	^ textCopy! !

!MondrianTutorial methodsFor: 'lessons' stamp: 'AlexandreBergel 9/19/2010 12:52'!
tutorial
	^ #(
		t01Introduction 
		t02FirstVisualization 
		t03VisualizingClasses 
		t04GivingANewShape
		t05MultipleEdges
		t06Colors
		t07MoreOnColors
		t08Popupview
		t09Subviews
		t10ForwardingEvents
		t11Events
		t12Interactions
		t13Conclusion
		)! !

!MondrianTutorial methodsFor: 'latex generation - private' stamp: 'Alexandre Bergel 11/15/2010 18:22'!
writeBodyOn: stream
	self lessons do: [ :lesson | self writeLesson: lesson on: stream ]! !

!MondrianTutorial methodsFor: 'latex generation - private' stamp: 'Alexandre Bergel 11/15/2010 19:59'!
writeFootOn: stream
	latexTheme writeFootOn: stream! !

!MondrianTutorial methodsFor: 'latex generation - private' stamp: 'Alexandre Bergel 11/15/2010 19:59'!
writeHeaderOn: stream.
	latexTheme writeHeaderOn: stream.! !

!MondrianTutorial methodsFor: 'latex generation - private' stamp: 'Alexandre Bergel 11/15/2010 19:24'!
writeLesson: aLesson on: stream 
	stream 
		nextPutAll: '\section{';
		nextPutAll: aLesson title;
		nextPutAll: '}'; cr.
		
	stream nextPutAll: (self translateLessonIntoLatex: aLesson lesson).
	
	stream nextPutAll: '%====================='; cr; cr! !

Object subclass: #LatexTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Help'!

!LatexTheme commentStamp: '<historical>' prior: 0!
LatexTheme is a latex exporter for the Mondrian documentation.

LatexTheme is an abstract class. The following methods needs to be implemented
	#mapping	#writeFootOn:	#writeHeaderOn:

Class collaborations
	MondrianTutorial 

Class public API
		#figureScale	#mapping	#writeFootOn:	#writeHeaderOn:

Testing classes
	MondrianTutorialTest 


Comments written by AlexandreBergel on 28 April 2011
!

!LatexTheme methodsFor: 'configuration' stamp: 'Alexandre Bergel 11/17/2010 00:00'!
figureScale
	^ 0.40! !

!LatexTheme methodsFor: 'hooks' stamp: 'Alexandre Bergel 11/16/2010 11:18'!
mapping
	self subclassResponsibility! !

!LatexTheme methodsFor: 'hooks' stamp: 'Alexandre Bergel 11/16/2010 11:18'!
writeFootOn: stream
	self subclassResponsibility! !

!LatexTheme methodsFor: 'hooks' stamp: 'Alexandre Bergel 11/16/2010 11:18'!
writeHeaderOn: stream
	self subclassResponsibility! !

LatexTheme subclass: #PharoByExampleLatexTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Help'!

!PharoByExampleLatexTheme commentStamp: '<historical>' prior: 0!
PharoByExampleLatexTheme  is a latex exporter. The exported document is intended to be part of the PharoByExample book.

Class collaborations
	MondrianTutorial 

Class public API
		#figureScale	#mapping	#writeFootOn:	#writeHeaderOn:

Testing classes
	
Comments written by AlexandreBergel on 28 April 2011
!

!PharoByExampleLatexTheme methodsFor: 'configuration' stamp: 'AlexandreBergel 11/17/2010 15:41'!
figureScale
	^ 0.30! !

!PharoByExampleLatexTheme methodsFor: 'hooks' stamp: 'AlexandreBergel 11/17/2010 15:42'!
mapping
	^ { 
		'<code>' ->  [ :text | '\begin{code}{}' ] .	
		'</code>' -> [ :text | '\end{code}' ] .
		'<image>' ->  [ :text | '\begin{center}\includegraphics[scale=', self figureScale printString, ']{figures/' ] .	
		'</image>' -> [ :text | '}\end{center}', String cr ] .
										
		'<sel>(\w|\:)*</sel>' -> [ :text | '\ct{', 
											  (text copyFrom: '<sel>' size +1 to: (text size - '</sel>' size) ),
											 '}'] .
		'\<tutorial\>' -> [ :text | 'chapter' ] .
		'\<Tutorial\>' -> [ :text | 'Chapter'] .
		'	' -> [ :text | '        ' ].
"		'\|' -> [ :text | '\stBar~']"
	}
! !

!PharoByExampleLatexTheme methodsFor: 'hooks' stamp: 'Alexandre Bergel 11/15/2010 19:56'!
writeFootOn: stream
	stream nextPutAll: 
'
%=============================================================
\ifx\wholebook\relax\else
   \bibliographystyle{jurabib}
   \nobibliography{scg}
   \end{document}
\fi
%=============================================================




%-----------------------------------------------------------------

%%% Local Variables:
%%% coding: utf-8
%%% mode: latex
%%% TeX-master: t
%%% TeX-PDF-mode: t
%%% ispell-local-dictionary: "english"
%%% End:'! !

!PharoByExampleLatexTheme methodsFor: 'hooks' stamp: 'Alexandre Bergel 11/15/2010 19:55'!
writeHeaderOn: stream.
	stream nextPutAll: 
'
%=================================================================
\ifx\wholebook\relax\else
% --------------------------------------------
% Lulu:
	\documentclass[a4paper,10pt,twoside]{book}
	\usepackage[
		papersize={6.13in,9.21in},
		hmargin={.75in,.75in},
		vmargin={.75in,1in},
		ignoreheadfoot
	]{geometry}
	\input{../common.tex}
	\setboolean{lulu}{true}
% --------------------------------------------
% A4:
%	\documentclass[a4paper,11pt,twoside]{book}
%	\input{../common.tex}
%	\usepackage{a4wide}
% --------------------------------------------
    \graphicspath{{figures/} {../figures/}}
	\begin{document}
\fi
%=================================================================
%\renewcommand{\nnbb}[2]{} % Disable editorial comments
\sloppy
%=================================================================
\chapter{Mondrian}
\chalabel{mondrian}
'! !

LatexTheme subclass: #StandAloneLatexTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Help'!

!StandAloneLatexTheme commentStamp: '<historical>' prior: 0!
StandAloneLatexTheme is a latex exporter. The exported document is standalone

Class collaborations
	MondrianTutorial 

Class public API
		#mapping	#writeFootOn:	#writeHeaderOn:

Testing classes
	




Comments written by AlexandreBergel on 28 April 2011
!

!StandAloneLatexTheme methodsFor: 'hooks' stamp: 'Alexandre Bergel 11/16/2010 19:07'!
mapping
	^ { 
		'<code>' ->  [ :text | '\begin{verbatim}' ] .	
		'</code>' -> [ :text | '\end{verbatim}' ] .
		'<image>' ->  [ :text | '\begin{center}\includegraphics[scale=', self figureScale printString, ']{figures/' ] .	
		'</image>' -> [ :text | '}\end{center}', String cr ] .
										
		'<sel>(\w|\:)*</sel>' -> [ :text | '\co{\#', 
											  (text copyFrom: '<sel>' size +1 to: (text size - '</sel>' size) ),
											 '}'] .
		'\<tutorial\>' -> [ :text | 'chapter' ] .
		'\<Tutorial\>' -> [ :text | 'Chapter'] .
		'	' -> [ :text | '  ' ].
"		'\|' -> [ :text | '\stBar~']"
	}! !

!StandAloneLatexTheme methodsFor: 'hooks' stamp: 'Alexandre Bergel 11/15/2010 20:00'!
writeFootOn: stream
	stream 
		nextPutAll: '\end{document}'; 
		cr! !

!StandAloneLatexTheme methodsFor: 'hooks' stamp: 'Alexandre Bergel 11/16/2010 01:12'!
writeHeaderOn: stream.
	stream 
		nextPutAll: '\documentclass{article}'; cr;
nextPutAll: '\usepackage{graphicx}
\usepackage{ifthen}
\usepackage{xspace}
\usepackage{alltt}
';
		nextPutAll: '\newcommand{\co}[1]{{\small\textsf{#1}\xspace}}';cr;
		nextPutAll: '\begin{document}'; cr.! !
